Ext.regModel('status', {
    fields: [
        { name: 'status', type: 'string' },
    ]
});


Ext.regModel('promo', {
    fields: [
        { name: 'value', mapping: '@id', type: 'string' },
        { name: 'descr', mapping: '@name', type: 'string' }
    ]
});

Ext.regModel('categories', {
    fields: [
               { name: 'value', mapping: '@value', type: 'string' },
               { name: 'descr', mapping: '@descr', type: 'string' }
            ]
});

Ext.regModel('makers', {
    fields: [
               { name: 'value', mapping: '@value', type: 'string' },
               { name: 'descr', mapping: '@descr', type: 'string' }
            ]
});

Ext.regModel('years', {
    fields: [
               { name: 'value', mapping: '@value', type: 'string' },
               { name: 'descr', mapping: '@descr', type: 'string' }
            ]
});

Ext.regModel('kilometers', {
    fields: [
               { name: 'value', mapping: '@value', type: 'string' },
               { name: 'descr', mapping: '@descr', type: 'string' }
            ]
});

Ext.regModel('fuels', {
    fields: [
               { name: 'value', mapping: '@value', type: 'string' },
               { name: 'descr', mapping: '@descr', type: 'string' }
            ]
});

Ext.regModel('prices', {
    fields: [
               { name: 'value', mapping: '@value', type: 'string' },
               { name: 'descr', mapping: '@descr', type: 'string' }
            ]
});

Ext.regModel('model', {
    fields: [
               { name: 'value', mapping: '@value', type: 'string' },
               { name: 'descr', mapping: '@descr', type: 'string' }
            ]
});

Ext.regModel('outlets', {
    fields: [
               { name: 'value', mapping: '@value', type: 'string' },
               { name: 'descr', mapping: '@descr', type: 'string' }
            ]
});


Ext.regModel('ricerca', {
    fields: [
               { name: 'soloOffertePrimoPiano', type: 'boolean' },
               { name: 'make', type: 'string' },
               { name: 'year', type: 'string' },
               { name: 'km', type: 'string' },
               { name: 'category', type: 'string' },
               { name: 'fuel', type: 'string' },
               { name: 'price', type: 'string' },
               { name: 'model', type: 'string' }
            ]
});

Ext.regModel('localRicerca', {
    fields: [
               { name: 'id'},
               { name: 'name', type: 'string' },
               { name: 'soloOffertePrimoPiano', type: 'boolean' },
               { name: 'make', type: 'string' },
               { name: 'year', type: 'string' },
               { name: 'km', type: 'string' },
               { name: 'category', type: 'string' },
               { name: 'fuel', type: 'string' },
               { name: 'price', type: 'string' },
               { name: 'model', type: 'string' },
               { name: 'outlet', type: 'string' },
               { name: 'makeDescr', type: 'string' },
               { name: 'yearDescr', type: 'string' },
               { name: 'kmDescr', type: 'string' },
               { name: 'categoryDescr', type: 'string' },
               { name: 'fuelDescr', type: 'string' },
               { name: 'priceDescr', type: 'string' },
               { name: 'modelDescr', type: 'string' }
            ]
}); 

                                
Ext.regModel('offer', {
    fields: [
               { name: 'id' },
               { name: 'offer', mapping: '@id' },
               { name: 'isPromo', mapping: '@isPromo', type: 'boolean' },
               { name: 'brand' },
               { name: 'model' },
               { name: 'version' },
               { name: 'registrationDate' },
               { name: 'km' },
               { name: 'price' },
               { name: 'outlet' },
               { name: 'category' },
               { name: 'image' }
            ]
});

Ext.regModel('localDetail', {
    fields: [
               { name: 'id' },
               { name: 'status', type: 'string' },
               { name: 'offer', type: 'string' },
               { name: 'isPromo', type: 'boolean' },
               { name: 'targa', mapping: '@numberPlate' },
               { name: 'brand' },
               { name: 'model' },
               { name: 'version' },
               { name: 'registrationDate' },
               { name: 'km' },
               { name: 'price' },
               { name: 'outlet' },
               { name: 'category' },
               { name: 'color' },
               { name: 'image' }
            ]
});



Ext.regModel('detail', {
    fields: [
               { name: 'offer', mapping: '@id' },
               { name: 'isPromo', mapping: '@isPromo', type: 'boolean' },
               { name: 'targa', mapping: '@numberPlate' },
               { name: 'brand' },
               { name: 'model' },
               { name: 'version' },
               { name: 'registrationDate' },
               { name: 'km' },
               { name: 'price' },
               { name: 'outlet' },
               { name: 'category' },
               { name: 'color' },
            ],
            associations: [{ type: 'hasMany', model: 'equipment', name: 'equipments' },
                           { type: 'hasMany', model: 'image', name: 'image' }]
});

Ext.regModel('equipment', {
	fields: [
	         {name: 'equipment', mapping: '.' }
	],
	belongsTo: 'detail',
	proxy: {
		type:'ajax',
		reader: {	
			type: 'xml',
			//root: 'equipments',
			record: 'equipment'
			}
	}
});
Ext.regModel('image', {
	fields: [
		{name: 'medium', mapping: '.' },
		{name: 'isMain', mapping: '@isMain' }
	],
	belongsTo: 'detail',
	proxy: {
		type:'ajax',
		reader: {	
			type: 'xml',
			root: 'image',
			record: 'medium'
		}
	}
});   

Ext.regModel('outlet', {
    hasMany: {
        model: 'Outlet',
        name: 'outlets'
    },
    fields: [
               { name: 'id', mapping: '@id', type: 'string' },
               { name: 'name' },
               { name: 'description' },
               { name: 'town' },
               { name: 'zipcode' },
               { name: 'street' },
               { name: 'city' },
               { name: 'phone' },
               { name: 'mobile' },
               { name: 'geo-lat' },
               { name: 'geo-lng' },
               { name: 'distance',type: 'float',defaultValue: 0 },
            ],
            updateDistanceFrom: function(currentLat,currentLng) {
            		var lat = this.get('geo-lat');
            		var lng = this.get('geo-lng');	
           		
            		if(currentLat && lat){   
	            		var loc1 = new google.maps.LatLng(currentLat, currentLng);
	                    var loc2 = new google.maps.LatLng(lat,lng); 
	                    var distanza = loc2.distanceFrom(loc1).toFixed(1);            
	                    this.set('distance', distanza); 
	            	}
            }
});

Ext.regModel('status', {
    fields: [
               { name: 'status' }
            ]
});