arval.views.OutletList = Ext.extend(Ext.Panel, {
    layout: 'card',
    initComponent: function() {
    	var OutletStore = new Ext.data.Store({
    		model: 'outlet',
    		autoLoad:true,
    		/*
    		 getGroupString: function(r){
    		    return r.get('name')[0]
    		},*/
    		proxy: {
    		    type: 'ajax',
    		    url : /* 'xml_outlet.xml', */ 'http://m.arvalusato.it/mobile/outletList.action', 
    		    reader: {
    			type  : 'xml',
    			root  : 'outlets',
    			record: 'outlet'
    		    }
    		},
    		listeners: {
    			load: function(store){
    					store.filterBy(function(record, id) {
    					    return ((record.get('geo-lat') != '') || (record.get('geo-lng') != ''));
    					}, this);	
    						
    				}
    		}
    	});
    	this.geo = new Ext.util.GeoLocation({
    	    autoUpdate: true,
    	    listeners: {
    	        locationupdate: function (geo) {
    	        	//aggiorno distanza
    	        	var store = Ext.getCmp("outletlist").list.store;
    	        	store.each(function(rec) {
    	        	          rec.updateDistanceFrom( Ext.getCmp("outletlist").geo.coords.latitude, Ext.getCmp("outletlist").geo.coords.longitude);

    	        	});
    	        
    	        	store.sort('distance','ASC');
    	        }
    	    }
     });
    	   	
     this.outletTpl = new Ext.XTemplate(
    		  '<div id="address">',
          			'<div id="name">{name}</div>',
          			'<div id="description">{street} - {town} {zipcode} </div>', //- {city}
          		'</div>',
          		'<div id="map" style="float: right">',
          		'	{[this.distance(values["distance"])]} &nbsp;<img src="images/greenArrow.png" height="40" style="vertical-align:middle;">',
          		'</div>',
          		{
          	        // XTemplate configuration:
          	        compiled: true,
          	        // member functions:
          	        distance: function(distance){
          	        	if(distance){
          	        		 return distance+ ' km';
          	        	} else {
          	        		return '';
          	        		
          	        	}
          	        }
          	    }
    		);	
    	
    	
       this.list = new Ext.List({
	    itemCls: 'OutletList',
	    pressedCls: 'OutletListOver',
            itemTpl: this.outletTpl,
            store: OutletStore,
            listeners: {
                selectionchange: {fn: this.onSelect, scope: this}
            }
        });
       
        this.listpanel = new Ext.Panel({
	    dockedItems: [{
                xtype: 'toolbar',
                title: 'Outlet',
                items: [{
                    	ui: 'marchioUC',
                    	text: ''
                	},
                		{xtype: 'spacer'},
                		{xtype: 'spacer'},
                	{
                			ui: 'logoUC',
                			text: ''
                	}
                	]
	    }],
	    layout: 'fit',
	    items: this.list,
            listeners: {
                activate: { fn: function(){
                    this.list.getSelectionModel().deselectAll();
                    this.geo.updateLocation();
                    Ext.repaint();
                }, scope: this }
            }
        });
       
        this.items = this.listpanel;
        
        
        arval.views.OutletList.superclass.initComponent.call(this);
    },
    listeners: {
                activate : function() {
                    trackPage('/android/outletlist');
                }
            },
    
    onSelect: function(sel, records){
        if (records[0] !== undefined) {
            
            var outletMap = new arval.views.OutletMap({
                prevCard:  Ext.getCmp('outletlist').getActiveItem(),
            	caller: 'outletlist',
                record: records[0]
            });
            Ext.getCmp('outletlist').setActiveItem(outletMap, false);
        }
    }
});

Ext.reg('outletlist', arval.views.OutletList);