arval.views.OutletMap = Ext.extend(Ext.Panel, {
    
    //layout: 'card',
    
    initComponent: function(){
    	this.id = this.caller+'outletmap';
    	var caller = this.caller;
        this.dockedItems = [{
            xtype: 'toolbar',
            title: 'Outlet',
            items: [{
                ui: 'back',
                text: 'Back',
                scope: this,
                handler: function(){
                	Ext.getCmp(this.caller).setActiveItem(this.prevCard, {
                        type: 'fade',
                        reverse: true,
                        scope: this,
                        after: function(){
                            this.destroy();
                            //this.remove(this.prevCard, true);
                        }
                    });
                }
            },
            {xtype: 'spacer'},
            {xtype: 'spacer'},
            {
            ui: 'logoUC',
            text: ''
            }
            ]
        }];
        
        var geolat = this.record.get('geo-lat');
        var geolng = this.record.get('geo-lng');   

        this.map = new Ext.Map({
        		useCurrentLocation : true,
                mapOptions : {
                    center : new google.maps.LatLng(geolat, geolng),
                    zoom : 12,
                    mapTypeId : google.maps.MapTypeId.ROADMAP,
                    navigationControl: true,
                    navigationControlOptions: {
                            style: google.maps.NavigationControlStyle.DEFAULT
                        }
                },
                listeners : {
                    maprender : function(comp, map){
                        new google.maps.Marker({
                            position: new google.maps.LatLng(geolat, geolng),
                            map: map
                        });    
                        
                        Ext.getCmp('outletlist').geo.updateLocation();                       
                    }
            
                }                              
        });        

        this.items = [{
                    tpl: new Ext.XTemplate( 
                    		'<div class="OutletMap">',
                    			'<div style="float: left; width: 49%; margin-right: 1%;">',
	                    			'<div id="name">{name}</div>',
	                    			'<div id="description">{street} {description} {zipcode} - {town} </div>', //<tpl if="city != \'\'">({city})</tpl>
	                    			'<tpl if="distance != \'\'"><div style="margin-top: 4px;font-size: 0.7em;">{[ this.addCmp({xtype:"button", ui: "green", text:"Calcola il percorso", handler:function fn(){Ext.getCmp("'+this.caller+'outletmap").gotoMap(); } }) ]}</div></tpl>',
                    			'</div>',
                    			'<div style="float: left; width: 49%; margin-left: 1%;">',
                    				'<div id="distanza"><tpl if="distance != 0">dista {distance} km</tpl></div>',
                    				'<div id="description"><tpl if="phone != \'\'">Telefono: {phone}</tpl></div>',
                    				'<div id="description"><tpl if="mobile != \'\'">Mobile: {mobile}</tpl></div>',
                    			'</div>',
                    			'<div style="clear:both"></div>',
                    			
                    		'</div>'),
                    data: this.record.data  
            },
                    this.map];

        
        this.gotoMap = function(){    	
        	var lat = this.record.data['geo-lat'];
        	var lng = this.record.data['geo-lng'];
        	
        	
        	Ext.Msg.confirm("", "Continuando verra' aperta l'applicazione Mappe per aiutarti a raggiungere l'Outlet.\nVuoi continuare?", function(e){
        		
        		if(e == 'yes'){        			
	                var urlGoogle = 'http://maps.google.com/maps?saddr='+Ext.getCmp('outletlist').geo.latitude +','+Ext.getCmp('outletlist').geo.longitude+'&daddr='+lat+','+lng;
	        		var outletMapRoute = new arval.views.OutletMapRoute({
	                	caller: caller,
	        			urlGoogle: urlGoogle,
	                	prevCard: Ext.getCmp(caller).getActiveItem()
	                });               
	                Ext.getCmp("outletlist").setActiveItem(outletMapRoute, false);
	                
        		}
        	});
        };
        
       //_gaq.push(['_trackPageview', '/android/outlet/'+encodeURIComponent(this.record.data['name'])]);
        arval.views.OutletMap.superclass.initComponent.call(this);
    },
    listeners : {
                activate : function() {
                    trackPage('/android/outlet/'+encodeURIComponent(this.record.data['name']));
                }
            }
});

Ext.reg('outletmap', arval.views.OutletMap);
