arval.views.Searchcard = Ext.extend(Ext.Panel, {
    layout: 'card',
    initComponent: function() {     
                  	
        var store = function(name, root, record){
            name = new Ext.data.Store({
                                model: name,
                                autoload: true,
                                proxy: {
                                    type: 'ajax',
                                    //url: 'xml_filtri_ricerca.xml',
                                    url : 'http://m.arvalusato.it/mobile/facetsList.action', 
                                    reader: {
                                        type  : 'xml',
                                        root  : root,
                                        record: record
                                    }
                                }
                    });
            
            name.add({value: 'all', descr: '-'});
            name.sync();
            return name;
        }
        
        
        
        var storeModels = new Ext.data.Store({
            model: 'model',
            autoLoad:false,
             proxy: {
                 type: 'ajax',
                 url : 'http://m.arvalusato.it/mobile/modelsList.action',
                 reader: {
                     type  : 'xml',
                     root  : 'model-results',
                     record: 'model'
                 }
                 
             },
             listeners : {
                load : function(store) {
                    store.sync();
                    store.add({value: 'all', descr: '-'});
                    
                }
            }
        });
        storeModels.load({params:{make: 0 }});
        storeModels.sync();
        
        var storeMakers = store('makers', 'makers', 'make');
        var storeYears = store('years', 'years', 'year');
        var storeKilometers = store('kilometers', 'kilometers', 'km');
        var storeCategories = store('categories', 'categories', 'category');
        var storeFuels = store('fuels', 'fuels', 'fuel');
        var storePrices = store('prices', 'prices', 'price');   	
        var storeOutlets = store('outlets', 'outlets', 'outlet');
        
        
        var formRicerca = new Ext.form.FormPanel({
            id: 'formRicerca',
            scroll: 'vertical',

            
            plugins: [new Ext.ux.touch.ListPullRefresh({
                listeners: {
                   'released': function(plugin,list){                	   
                	   list.reset();
                	   storeModels.load({params:{make: 0 }});
                       storeModels.sync();
                       storeModels.clearFilter();
                       storeModels.filter('value', 'all');
                       Ext.getCmp('model').reset();
                       //formRicerca.setValues().model = ({ value: 'all', descr: '-'});
                       Ext.getCmp('model').disable();
                   }
                }
            })],
            
            dockedItems: [{
                xtype: "toolbar",
                title: "Ricerca",
                items: [
                        {ui: 'marchioUC',
                        text: '' },
                        {xtype: 'spacer'},
                        {xtype: 'spacer'},
                        {
                        text: 'Ricerca',
                        ui: 'green',
						handler: function() {
					
							//alert(formRicerca.getValues().make);
							var modelDescr = '';
							if(storeModels.find('value',formRicerca.getValues().model) != -1){
        						modelDescr = storeModels.getAt(storeModels.find('value',formRicerca.getValues().model)).get('descr');
        					}
	                        var ricercaResults = new arval.views.ricercaResults({
	                            prevCard: formRicerca,
	                            
	                            soloOffertePrimoPiano: formRicerca.getValues().soloOffertePrimoPiano,
	                            
	                            make: formRicerca.getValues().make,
	                            makeDescr: storeMakers.getAt(storeMakers.find('value',formRicerca.getValues().make)).get('descr'),
	                            
	                            year: formRicerca.getValues().year,
	                            yearDescr: storeYears.getAt(storeYears.find('value',formRicerca.getValues().year)).get('descr'),
	                            
	                            km: formRicerca.getValues().km,
	                            kmDescr: storeKilometers.getAt(storeKilometers.find('value',formRicerca.getValues().km)).get('descr'),
	                           
	                            category: formRicerca.getValues().category,
	                            categoryDescr: storeCategories.getAt(storeCategories.find('value',formRicerca.getValues().category)).get('descr'),
	                            
	                            fuel: formRicerca.getValues().fuel,
	                            fuelDescr: storeFuels.getAt(storeFuels.find('value',formRicerca.getValues().fuel)).get('descr'),
	                            
	                            price: formRicerca.getValues().price,
	                            priceDescr: storePrices.getAt(storePrices.find('value',formRicerca.getValues().price)).get('descr'),
	                            
	                            outlet: formRicerca.getValues().outlet,
	                            
	                            model: formRicerca.getValues().model,
	                            modelDescr: modelDescr,
	                            caller: 'ricerca',
	                            save: true
	                        });                      
	                        //this.setActiveItem(ricercaResults, 'slide');
	                        Ext.getCmp('ricerca').setActiveItem(ricercaResults, false);
	                    }
                }]
            }],
            items: [
                    {
                        xtype: 'fieldset',
                        defaults: {
                                labelAlign: 'left',
                                labelWidth: '50%'
                        },                
                        items:[
                                {
                                    xtype: 'togglefield',
                                    name : 'soloOffertePrimoPiano',
                                    label: 'Solo offerte in primo piano',
                                    value: true
                                }
                            ]
                    },
                    {
                        xtype: 'fieldset',
                        defaults: {
                                labelAlign: 'left',
                                labelWidth: '42%'
                        },                
                        items:[{
                                    xtype: 'selectfield',
                                    name : 'make',
                                    label: 'Marca',
                                    //valueField : 'Tutti',
                                    displayField : 'descr',
                                    store : storeMakers,
                                    scope: this,
                                    listeners: { scope: this,
                                                 change: function(){                                                    
                                                    if(formRicerca.getValues().make != 'all'){                                                      
                                                        storeModels.clearFilter();                                                        

                                                        storeModels.load({params:{make: formRicerca.getValues().make}});
                                                                                                 
                                                        Ext.getCmp('model').getListPanel().setHeight(200);
                                                        Ext.getCmp('model').enable();
                                                        
                                                    }else{
                                                        storeModels.load({params:{make: 0 }});
                                                        storeModels.sync();
                                                        storeModels.clearFilter();
                                                        storeModels.filter('value', 'all');
                                                        Ext.getCmp('model').reset();
  
                                                        Ext.getCmp('model').disable();
                                                    }
                                                   
                                                    }
                                                }                                
                                },
                                {
                                    xtype: 'selectfield',
                                    name : 'model',
                                    id : 'model',
                                    label: 'Modello',
                                    
                                    displayField : 'descr',
                                    store : storeModels,
                                    listeners: {

                                    }
                                                                
                                }
                            ]
                    },
                    {
                        xtype: 'fieldset',
                        defaults: {
                                labelAlign: 'left',
                                labelWidth: '42%'
                        },                
                        items:[
                                {
                                    xtype: 'selectfield',
                                    name : 'year',
                                    label: 'Anno',
                                    displayField : 'descr',
                                    store : storeYears
                                },
                                {
                                    xtype: 'selectfield',
                                    name : 'km',
                                    label: 'km',
                                    displayField : 'descr',
                                    store : storeKilometers
                                }
                            ]
                    },
                    {
                        xtype: 'fieldset',
                        defaults: {
                                labelAlign: 'left',
                                labelWidth: '42%'
                        },                
                        items:[
                                {
                                    xtype: 'selectfield',
                                    name : 'category',
                                    label: 'Categoria',
                                    displayField : 'descr',
                                    store : storeCategories
                                },
                                {
                                    xtype: 'selectfield',
                                    name : 'fuel',
                                    label: 'Alimentazione',
                                    displayField : 'descr', 
                                    store : storeFuels
                                }
                            ]
                    },
                    { 
                        xtype: 'fieldset',
                        defaults: {
                                labelAlign: 'left',
                                labelWidth: '42%'
                        },                
                        items:[
                                {
                                    xtype: 'selectfield',
                                    name : 'price',
                                    label: 'Prezzo',
                                    displayField : 'descr',
                                    store : storePrices
                                },
                            ]
                    },
                    {
                        xtype: 'fieldset',
                        defaults: {
                                labelAlign: 'left',
                                labelWidth: '42%'
                        },                
                        items:[
                                {
                                    xtype: 'selectfield',
                                    name : 'outlet',
                                    label: 'Outlet',
                                    displayField : 'descr',
                                    valueField: 'descr',
                                    store : storeOutlets
                                }                              
                            ]
                    }     
              ]
        });
        Ext.getCmp('model').disable();

        this.items = [formRicerca];
        
		//_gaq.push(['_trackPageview', '/android/ricerca']);
        arval.views.Searchcard.superclass.initComponent.apply(this, arguments);
    },
    listeners : {
                activate : function() {
                    trackPage('/android/ricerca');
                }
            }
});

Ext.reg('ricerca', arval.views.Searchcard);