arval.views.richiestaInfo = Ext.extend(Ext.Panel, {
	layout: 'card',
    initComponent: function() {
        
        var storeRichiestaInfo = new Ext.data.Store({
	    model: 'status',
	    autoLoad:false,
	    proxy: {
		type: 'ajax',
		url : 'http://m.arvalusato.it/mobile/sendLead.action',
		reader: {
		    type  : 'xml',
		    record  : 'status'
		}
	    },
            listeners:{
                load: function(store){

                }
            }
	});
        
        var targa = this.targa;
        var caller = this.caller;
        var prevCard = this.prevCard;
        
        function form_input_is_numeric(input){
            return !isNaN(input);
        }
        
	   function form_input_is_email(str) {
		   var filter=/^([\w-]+(?:\.[\w-]+)*)@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$/i
		   if (filter.test(str)){
			   return true;
		   }else{
			   Ext.Msg.alert('', 'Inserire un\'email valida', Ext.emptyFn);
			   return false;
		   }
	   	}

        		
        var formRichiestaInfo = new Ext.form.FormPanel({
        		scroll: 'vertical',
                params:{
                        targa: targa
                },
                method: 'POST',
                standardSubmit: false,
                url: 'http://m.arvalusato.it/mobile/sendLead.action',
                dockedItems: [{
                    xtype: "toolbar",
                    title: "Richiesta info",
                    items: [
                           {
                                ui: 'back',
                                text: 'Indietro',
                                scope: this,
                                handler: function(){
                                    Ext.getCmp(caller).setActiveItem(prevCard, {
                                        type: 'fade',
                                        reverse: true,
                                        scope: this,
                                        after: function(){
                                            this.destroy();
                                        }
                                    });
                                
                                    
                                }
                            },
                            {xtype: 'spacer'},
                            {xtype: 'spacer'},
                            {
                                text: 'Invia',
                                ui: 'green',
                                handler: function() {

                                	
                                	if(form_input_is_email(formRichiestaInfo.getValues().email)){
	                                	if(form_input_is_numeric(formRichiestaInfo.getValues().telefono)){
		                                    if((formRichiestaInfo.getValues().nome != '') &&
		                                       (formRichiestaInfo.getValues().cognome!= '') &&
		                                       (formRichiestaInfo.getValues().email != '') &&
		                                       (formRichiestaInfo.getValues().telefono != '')){ 
		                                            formRichiestaInfo.submit();
		                                        Ext.Msg.minHeight = 120;
		                                        Ext.Msg.alert('', 'Richiesta inviata, sarai contattato a breve da un nostro incaricato', Ext.emptyFn);
		                                        Ext.getCmp(caller).setActiveItem(prevCard, {
		                                            type: 'fade',
		                                            reverse: true,
		                                            scope: this,
		                                            after: function(){
		                                                this.destroy();
		                                                //this.remove(this.prevCard, true);
		                                            }
		                                        });
		                                    }else{
		                                    	Ext.Msg.alert('', 'Compilare tutti i campi', Ext.emptyFn);
		                                    }
	                                	}else{
	                                		Ext.Msg.alert('', 'Telefono errato', Ext.emptyFn);
	                                	}  	
                                	}
                                }
                    }]
                }],
                items: [{                  
                        	
                            xtype: 'fieldset',
                            defaults: {
                                    labelAlign: 'left',
                                    labelWidth: '40%'
                            },                
                            items:[{
                                        xtype: 'textfield',
                                        name : 'nome',
                                        label: 'Nome',
                                        useClearIcon: true,
                                        placeHolder: 'Nome'
                                    },
                                   {
                                        xtype: 'textfield',
                                        name : 'cognome',
                                        label: 'Cognome',
                                        useClearIcon: true,
                                        placeHolder: 'Cognome'                                
                                    },
                                    {
                                        xtype: 'textfield',
                                        name : 'telefono',
                                        label: 'Telefono',
                                        useClearIcon: true,
                                        listeners  : {
                                            scope: this,    
                                            keyup: function(field) {
                                            	value = field.getValue();
                                            	if(!form_input_is_numeric(value)){
                                            		field.setValue(value.substring(0, (value.length-1))); 
                                            	}
                                            }
                                        }
                                    },
                                    {
                                        xtype: 'emailfield',
                                        name : 'email',
                                        label: 'email',
                                        displayField : 'email',
                                        useClearIcon: true,
                                        placeHolder: 'tua@email.com'     
                                    },
                                    {
                                        xtype: 'textareafield',
                                        name : 'note',
                                        label: 'Note',
                                        useClearIcon: true                                     
		                        	},
		                        	{
		                           		xtype: 'fieldset',
		                           		instructions: 'Presa visione dell\'informativa in materia di protezione dei dati personali'
		                        	},
		                            {
		                                xtype: 'togglefield',
		                                name : 'privacy',
		                                label: 'Acconsento',
		                                value: false
		                            },
		                            {
		                            	xtype: 'button',
		                            	ui: 'green',
		                                text: 'Informativa',
		                                handler: function(){
		                                	var privacy = new arval.views.privacy({
		                                		 prevCard: Ext.getCmp(caller).getActiveItem(),
		                                		 caller: caller
		                                	});
		                                		
		                                	Ext.getCmp(caller).setActiveItem(privacy, false);
		                                }
		                            },
		                            {
		                                xtype: 'fieldset',
		                                instructions: 'al trattamento dei miei dati personali per le finalit&agrave; di cui al punto 3 della medesima.'
		                            },
		                            {
                            			xtype: 'hiddenfield',
		                                name : 'targa',
	                                	value: this.targa
		                           }
		                   ]
                	}],
                html: '<br /><div style="width: 100%; border: 1px solid #ababab; border-top-left-radius: 15px; border-top-right-radius: 15px; background: -webkit-gradient(linear, left top, left bottom, from(#50ad92), to(#3f8c78)); color: #ffffff; text-align: left; padding-left: 10px">Richiedi informazioni</div>'+
                      '<div style="width: 100%; border: 1px solid #ababab; border-bottom-left-radius: 15px; border-bottom-right-radius: 15px; background: -webkit-gradient(linear, left top, left bottom, from(#e0c141), to(#ffffff)); text-align: left; padding-left: 10px">'+this.version+' <br>Targa '+this.targa+'</div>'
    });

        

        this.items = formRichiestaInfo;

        arval.views.info.superclass.initComponent.apply(this, arguments);
    },
    listeners : {
                activate : function() {
                    trackPage('/android/richiestainfo');
                }
            }
});

Ext.reg('richiestaInfo', arval.views.richiestaInfo);
